module Map where

import Prelude hiding (lookup)

data Map k v = Branch (Map k v) k v (Map k v) | Leaf deriving Show

instance Functor (Map k) where
    fmap = undefined

instance Foldable (Map k) where
    foldr = undefined 

instance (Ord k, Eq k, Eq v) => Eq (Map k v) where
    m1 == m2 = undefined

empty :: Map k v
empty = undefined

insert :: Ord k => k -> v -> Map k v ->  Map k v
insert = undefined

delete :: Ord k => k -> Map k v -> Map k v
delete = undefined

size :: Ord k => Map k v -> Int
size = undefined

fromList :: Ord k => [(k,v)] -> Map k v
fromList = undefined

toList :: Ord k => Map k v -> [(k, v)]
toList = undefined

elems :: Ord k => Map k v -> [v]
elems = undefined

lookup :: Ord k => k -> Map k v -> Maybe v
lookup = undefined
